<template>
  <div class="requests-page">
    <grid-container>
      <div>
        <transition name="fade"></transition>
        <base-tab
          :config="tabConfig"
          :titles="['all', 'pending', 'approved', 'denied']"
        >
          <template #content v-if="!showLoadingRequestsList">
            <base-tab-content>
              <base-table
                :data="requestsListAll"
                :titlesList="['date', 'reason', 'status']"
                title="all Requests"
              ></base-table>
            </base-tab-content>
            <base-tab-content>
              <base-table
                :data="requestsListPending"
                :titlesList="['date', 'reason', 'status']"
                title="pending Requests"
              ></base-table>
            </base-tab-content>
            <base-tab-content>
              <base-table
                :data="requestsListApproved"
                :titlesList="['date', 'reason', 'status']"
                title="approved Requests"
              ></base-table>
            </base-tab-content>
            <base-tab-content>
              <base-table
                :data="requestsListDenied"
                :titlesList="['date', 'reason', 'status']"
                title="denied Requests"
              ></base-table>
            </base-tab-content>
          </template>
          <template #loading>
            <base-loading v-if="showLoadingRequestsList" />
          </template>

          <template #actionsBar>
            <base-button theme="transparentPrimaryBorder" icon="plus"
              >Create new request</base-button
            >
          </template>
        </base-tab>
      </div>
    </grid-container>
  </div>
</template>

<script lang="ts">
import Vue from "vue";

//components
import GridContainer from "@/components/grid/GridContainer";
import BaseTab from "@/components/base/BaseTab/BaseTab";
import BaseTabContent from "@/components/base/BaseTab/tab-content/TabContent";
import BaseButton from "@/components/base/BaseButton";
import BaseCard from "@/components/base/BaseCard";
import BaseTable from "@/components/base/BaseTable/BaseTable";
import BaseLoading from "@/components/base/BaseLoading";

// utils
import { getContaierWidth } from "@/utils/general";

// VueX utils
import { mapState, mapActions, mapGetters } from "vuex";

export default Vue.extend({
  name: "RequestsPage",
  components: {
    GridContainer,
    BaseButton,
    BaseTable,
    BaseTab,
    BaseTabContent,
    BaseLoading
  },
  data: function() {
    return {
      tabConfig: {
        width: getContaierWidth()
      }
    };
  },

  computed: {
    ...mapState(["requestsListAll", "showLoadingRequestsList"]),
    ...mapGetters([
      "requestsListPending",
      "requestsListApproved",
      "requestsListDenied"
    ])
  },

  methods: {
    ...mapActions(["getRequestsFromApi"])
  },
  mounted() {
    this.getRequestsFromApi();
  }
});
</script>

<style module lang="scss"></style>
